using System;
using System.Text;

namespace Esempio5
{
    [AttributeUsage(AttributeTargets.All, Inherited = true, AllowMultiple = true)]
    public class AuthorAttribute : Attribute
    {
        private string _name;
        private string _comment = String.Empty;
        private string _contact = String.Empty;

        public AuthorAttribute(string name)
        {
            _name = name;
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public string Comment
        {
            get { return _comment; }
            set { _comment = value; }
        }

        public string Contact
        {
            get { return _contact; }
            set { _contact = value; }
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendFormat("Author: {0}", Name);
            if (!String.IsNullOrEmpty(Comment))
                sb.AppendFormat(", comment: {0}", Comment);
            if (!String.IsNullOrEmpty(Contact))
                sb.AppendFormat(", contact: {0}", Contact);
            return sb.ToString();
        }
    }
}
