﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace Esempio5
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            LoadSteps();
        }

        private void LoadSteps()
        {
            foreach (MethodInfo methodInfo in typeof(Steps).GetMethods())
            {
                ParameterInfo[] parameterInfos = methodInfo.GetParameters();
                if (methodInfo.Name.StartsWith("Step") && parameterInfos.Length == 1 && parameterInfos[0].ParameterType == typeof(Panel))
                {
                    ToolStripMenuItem toolStripMenuItem = new ToolStripMenuItem(methodInfo.Name, null, _stepsToolStripMenuItem_Click);
                    toolStripMenuItem.Tag = methodInfo;
                    _stepsToolStripMenuItem.DropDownItems.Add(toolStripMenuItem);

                    DescriptionAttribute[] descriptions = (DescriptionAttribute[]) methodInfo.GetCustomAttributes(typeof(DescriptionAttribute), false);
                    if (descriptions.Length == 1)
                    {
                        toolStripMenuItem.ToolTipText = descriptions[0].Description;
                    }
                }
            }
        }

        private void _stepsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem toolStripMenuItem = (ToolStripMenuItem) sender;
            MethodInfo methodInfo = (MethodInfo) toolStripMenuItem.Tag;
            methodInfo.Invoke(null, new object[] { _panel });
            toolStripMenuItem.Checked = true;
        }
    }
}
