using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;
using System.Reflection;

namespace Esempio5
{
    public abstract class OperationBase
    {
        public virtual string Name
        {
            get { return GetType().Name; }
        }

        public virtual string SymbolicName
        {
            get { return Name; }
        }

        public abstract double Evaluate(double operando1, double operando2);
    }

    public class Add : OperationBase
    {
        public override string SymbolicName
        {
            get { return "+"; }
        }

        public override double Evaluate(double operando1, double operando2)
        {
            return (operando1 + operando2);
        }
    }

    public class Sub : OperationBase
    {
        public override string SymbolicName
        {
            get { return "-"; }
        }

        public override double Evaluate(double operando1, double operando2)
        {
            return (operando1 - operando2);
        }
    }

    public class Mul : OperationBase
    {
        public override string SymbolicName
        {
            get { return "*"; }
        }

        public override double Evaluate(double operando1, double operando2)
        {
            return (operando1 * operando2);
        }
    }

    public class Div : OperationBase
    {
        public override string SymbolicName
        {
            get { return "/"; }
        }

        public override double Evaluate(double operando1, double operando2)
        {
            return (operando1 / operando2);
        }
    }

    public class Mod : OperationBase
    {
        public override string SymbolicName
        {
            get { return "%"; }
        }

        public override double Evaluate(double operando1, double operando2)
        {
            return (operando1 % operando2);
        }
    }
}
