﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.Collections;

namespace Esempio5
{
    public partial class OperationsView : UserControl
    {
        private IOperationsDescriptor _operationsDescriptor;

        public OperationsView(IEnumerable<IOperationsDescriptor> operationsDescriptors)
        {
            InitializeComponent();
            Build(operationsDescriptors);
        }

        private void Build(IEnumerable<IOperationsDescriptor> operationsDescriptors)
        {
            _contextMenuStrip.Items.Clear();
            foreach (IOperationsDescriptor operationsDescriptor in operationsDescriptors)
            {
                ToolStripMenuItem toolStripMenuItem = new ToolStripMenuItem(operationsDescriptor.MenuDescription, null, ToolStripMenuItem_Click);
                toolStripMenuItem.Tag = operationsDescriptor;
                _contextMenuStrip.Items.Add(toolStripMenuItem);
            }
            _contextMenuStrip.Items[0].PerformClick();
            //LoadOperations(operationsDescriptors.ElementAt(0));
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem toolStripMenuItem = (ToolStripMenuItem) sender;
            LoadOperations((IOperationsDescriptor) toolStripMenuItem.Tag);
        }

        private void LoadOperations(IOperationsDescriptor operationsDescriptor)
        {
            try
            {
                _operationsDescriptor = operationsDescriptor;
                _leftTextBox.Visible = operationsDescriptor.Diadic;
                _operationComboBox.DataSource = operationsDescriptor.GetOperations();
                _operationComboBox.DisplayMember = operationsDescriptor.DisplayMember;
            }
            catch (Exception exception)
            {
                _bottomPanel.WriteLine(exception.ToString());
            }
        }

        private void _evaluateButton_Click(object sender, EventArgs e)
        {
            try
            {
                _bottomPanel.WriteLine(_operationsDescriptor.GetResult(_operationComboBox.SelectedItem,
                    _operationComboBox.GetItemText(_operationComboBox.SelectedItem), _leftTextBox.Text, _rightTextBox.Text));
            }
            catch (Exception exception)
            {
                _bottomPanel.WriteLine(exception.ToString());
            }
        }
    }
}
