using System;

namespace Esempio5
{
    public class Studente
    {
        private readonly int _matricola;
        private string _cognome;
        private string _nome;
        private string _corsoDiStudio;
        private DateTime _dataDiNascita = DateTime.MinValue;
        private int _annoDiIscrizione = 0;

        public Studente(int matricola)
        {
            _matricola = matricola;
        }

        public int Matricola
        {
            get { return _matricola; }
        }

        public string Cognome
        {
            get { return _cognome; }
            set { _cognome = value; }
        }

        public string Nome
        {
            get { return _nome; }
            set { _nome = value; }
        }

        public string CorsoDiStudio
        {
            get { return _corsoDiStudio; }
            set { _corsoDiStudio = value; }
        }

        public DateTime DataDiNascita
        {
            get { return _dataDiNascita; }
            set { _dataDiNascita = value; }
        }

        public int AnnoDiIscrizione
        {
            get { return _annoDiIscrizione; }
            set { _annoDiIscrizione = value; }
        }

        public int Et
        {
            get
            {
                if (_dataDiNascita == DateTime.MinValue)
                    throw new ApplicationException("Impossibile calcolare l'et: DataDiNascita non presente");
                int anni = DateTime.Today.Year - _dataDiNascita.Year;
                return anni - (DateTime.Today.DayOfYear < _dataDiNascita.DayOfYear ? 1 : 0);
            }
        }

        public int AnnoDiCorso
        {
            get
            {
                if (_annoDiIscrizione == 0)
                    throw new ApplicationException("Impossibile calcolare l'anno di corso: AnnoDiIscrizione non presente");
                int annoDiCorso = DateTime.Today.Year - _annoDiIscrizione;
                return annoDiCorso + (DateTime.Today.Month >= 9 ? 1 : 0);
            }
        }

        public override string ToString()
        {
            return String.Format("Matr.: {0}, Cognome: {1}, Nome: {2}, Corso Di Studio: {3}, Data Di Nascita: {4:d}, Anno Di Iscrizione: {5}, Et: {6}, Anno Di Corso: {7}",
                Matricola, Cognome, Nome, CorsoDiStudio, DataDiNascita, AnnoDiIscrizione, Et, AnnoDiCorso);
        }
    }
}
