﻿using System;
using System.Linq;
using System.Text;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Reflection;

namespace Esempio5
{
    public static class TextBoxExtensions
    {
        public static void WriteLine(this TextBox textBox, object value = null)
        {
            if (value != null)
                textBox.AppendText(value.ToString());
            textBox.AppendText(Environment.NewLine);
        }

        public static void WriteLine(this TextBox textBox, string format, params object[] value)
        {
            textBox.AppendText(String.Format(format, value));
            textBox.AppendText(Environment.NewLine);
        }

        public static void Display(this TextBox textBox, object instance)
        {
            Type type = instance.GetType();
            foreach (PropertyInfo propertyInfo in type.GetProperties())
            {
                if (propertyInfo.CanRead && propertyInfo.GetIndexParameters().Length == 0)
                {
                    object value = propertyInfo.GetValue(instance, null);
                    textBox.WriteLine("{0} = {1}", propertyInfo.Name, value);
                }
            }
        }
    }
}
